/**
  Usa el ordenamiento por insersión para
  ordenar el contenido de un archivo.
  El archivo debe tener menos de 50 números enteros,
  un  número por cada línea

  Fraga, 4.07.2023
**/
#include <stdio.h>
#include <stdlib.h>

int leer_archivo( char *nombre, int A[], int n )
{
	FILE *parch;
	char linea[80];
	int i, a;

	// Abro el archivo
	parch = fopen( nombre, "r" );
	if( parch == NULL ) {
		fprintf( stderr, "ERROR: no existe el archivo %s\n", nombre );
		exit(-1);
	}
	// Leo el archivo
	i = 0;
	while( 1 ) {
		if( fgets( linea, 80, parch ) == NULL ){
			break;
		}
		if ( sscanf( linea, "%d", &a ) != 1 ){
			fprintf( stderr, "ERROR: no existe un número en la línea %d\n", i );
			exit(-2);
		}
		A[i] = a;
		i++;
		if( i>50 ){
			fprintf( stderr, "ERROR: ya leí 50 datos máximo\n" );
			i = 50;
			break;
		}
	}
	fclose( parch );
	return i;
}

void Ordenamiento_por_insercion( int A[], int n )
{
	int i, j, key;
	/**
	1   for j=2 to A.length
	2     key = A[j]
	3     # Inserta A[j] en la secuencia ordenada A[1..j-1]
	4     i = j - 1
	5     while i > 0 and A[i] > key
	6         A[i+1] = A[i]
	7         i -= 1
	8     A[i+1] = key 
	**/

	for( j=1; j<n; j++ ){
		key = A[j];
		// Inserta A[j] en la secuencia ordenada A[1..j-1]
		i = j - 1;
		while( i >= 0 && A[i] > key ) {
			A[i+1] = A[i];
			i--;
		}
		A[i+1] = key; 
	}
}

int main( int argc, char *argv[] )
{
	int i, n;
	int vv[50];

	if( argc !=2 ){
		fprintf( stderr, "Args: nombre_archivo\n" );
		return 1;
	}

	n = leer_archivo( argv[1], vv, 50 );

	Ordenamiento_por_insercion( vv, n );

	for( i=0; i<n; i++ ) 
		printf("%d\n", vv[i] );

	return 0;
}
